// The code has been written in ~1 hour.
// To make things worse, part of the code (window creation) has been written
// literally 10 years go.
// You have been warned.
#include <stdio.h>
#include <windows.h>

#define WINDOW_NAME "Brutal Oldskull"
#define WINDOW_CLASS_NAME "PrettyBrutalWindowClass"

#include "md5.h"
#include "oldskull_checker.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

HWND hcode[4];
HWND hflag;
HWND htext;
HWND hbutton_check;
HWND hbutton_about;
HINSTANCE hinst;

void calc_md5(void *data, size_t sz, char result[33]) {
  MD5_CTX md5;
  unsigned char res[16];

  MD5_Init(&md5);
  MD5_Update(&md5, data, sz);
  MD5_Final(res, &md5);

  for(int i = 0; i < 16; i++) {
    sprintf(&result[i * 2], "%.2x", res[i]);
  }
}

void SetMsg(const char *msg) {
  SetWindowText(htext, msg);
}

unsigned char* Decode(unsigned char *src, size_t sz, unsigned short code) {
  unsigned char *dst = (unsigned char*)malloc(sz);
  memset(dst, 0, sz);

  for (size_t i = 0; i < sz; i++) {
    dst[i] = (src[i] ^ (code & 0xff)) - ((code >> 8) & 0xff);
    code = (unsigned short)(((unsigned long)code * 3505283827) & 0xffff);
  }

  char result[40]{};
  calc_md5(dst, sz - 32, result);
  if (memcmp(result, dst + sz - 32, 32) != 0) {
    free(dst);
    return NULL;
  }

  return dst;
}

void CheckFlag() {
  SetMsg("Processing...");

  unsigned short code[4];

  for (int i = 0; i < 4; i++) {
    char buf[16]{};
    GetWindowText(hcode[i], buf, 8);

    unsigned int x;

    if (sscanf(buf, "%x", &x) != 1) {
      char txt[256];
      sprintf(txt, "Incorrect Code %i format (16-bit HEX)", i + 1);
      SetMsg(txt);
      return;
    }

    if (x > 0xffff) {
      SetMsg("Incorrect Code.");
      return;
    }

    code[i] = (unsigned short)x;
  }

  unsigned char *lvl1 = Decode(oldskull_checker, sizeof(oldskull_checker), code[0]);
  if (!lvl1) { SetMsg("Wrong Code 1."); return; }

  unsigned char *lvl2 = Decode(lvl1, sizeof(oldskull_checker) - 32 * 1, code[1]);
  if (!lvl2) { SetMsg("Wrong Code 2."); free(lvl1); return; }

  unsigned char *lvl3 = Decode(lvl2, sizeof(oldskull_checker) - 32 * 2, code[2]);
  if (!lvl3) { SetMsg("Wrong Code 3."); free(lvl1); free(lvl2); return; }

  unsigned char *lvl4 = Decode(lvl3, sizeof(oldskull_checker) - 32 * 3, code[3]);
  if (!lvl4) { SetMsg("Wrong Code 4."); free(lvl1); free(lvl2); free(lvl3); return; }

  free(lvl1);
  free(lvl2);
  free(lvl3);

  char path[512]{};
  GetTempPath(256, path);
  strcat(path, "\\oldskull_checker.exe");

  FILE *f = fopen(path, "wb");
  if (!f) {
    SetMsg("Couldn't write the checker file.");
    free(lvl4);
    return;
  }

  fwrite(lvl4, 1, sizeof(oldskull_checker) - 32 * 4, f);
  fclose(f);
  free(lvl4);

  STARTUPINFO si{};
  si.cb = sizeof(si);

  PROCESS_INFORMATION pi{};

  char flag[256]{};
  GetWindowText(hflag, flag, 64);

  strcat(path, " ");
  strcat(path, flag);

  BOOL ret = CreateProcess(
    NULL, path,
    NULL, NULL, FALSE, CREATE_NO_WINDOW, NULL, NULL,
    &si, &pi);

  if (!ret) {
    SetMsg("Couldn't spawn checker");
    return;
  }

  if (WaitForSingleObject(pi.hProcess, 2000) != 0) {
    TerminateProcess(pi.hProcess, 9);
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    SetMsg("Checker crashed. Sorry.");
    return;
  }

  DWORD exit_code = -1;
  ret = GetExitCodeProcess(pi.hProcess, &exit_code);
  if (!ret) {
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    SetMsg("Checker failed. Sorry.");
    return;
  }

  if (exit_code == 0) {
    SetMsg("Well Done! But you know that :)");
  } else {
    SetMsg("Wrong Flag.");
  }

  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
}

LRESULT CALLBACK
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    case WM_CREATE:
    hcode[0] = CreateWindowEx(0, "Edit", "", WS_CHILD | WS_VISIBLE | WS_BORDER, 90, 10, 200, 20, hwnd, NULL, hinst, NULL);
    hcode[1] = CreateWindowEx(0, "Edit", "", WS_CHILD | WS_VISIBLE | WS_BORDER, 90, 35, 200, 20, hwnd, NULL, hinst, NULL);
    hcode[2] = CreateWindowEx(0, "Edit", "", WS_CHILD | WS_VISIBLE | WS_BORDER, 90, 60, 200, 20, hwnd, NULL, hinst, NULL);
    hcode[3] = CreateWindowEx(0, "Edit", "", WS_CHILD | WS_VISIBLE | WS_BORDER, 90, 85, 200, 20, hwnd, NULL, hinst, NULL);

    CreateWindowEx(0, "Static", "Code 1: 0x", WS_CHILD | WS_VISIBLE, 10, 10, 80, 20, hwnd, NULL, hinst, NULL);
    CreateWindowEx(0, "Static", "Code 2: 0x", WS_CHILD | WS_VISIBLE, 10, 35, 80, 20, hwnd, NULL, hinst, NULL);
    CreateWindowEx(0, "Static", "Code 3: 0x", WS_CHILD | WS_VISIBLE, 10, 60, 80, 20, hwnd, NULL, hinst, NULL);
    CreateWindowEx(0, "Static", "Code 4: 0x", WS_CHILD | WS_VISIBLE, 10, 85, 80, 20, hwnd, NULL, hinst, NULL);

    hflag = CreateWindowEx(0, "Edit", "", WS_CHILD | WS_VISIBLE | WS_BORDER, 90, 110, 200, 20, hwnd, NULL, hinst, NULL);

    CreateWindowEx(0, "Static", "Final Flag", WS_CHILD | WS_VISIBLE, 10, 110, 80, 20, hwnd, NULL, hinst, NULL);

    htext = CreateWindowEx(0, "Static", "...", WS_CHILD | WS_VISIBLE, 10, 135, 280, 20, hwnd, NULL, hinst, NULL);

    hbutton_check = CreateWindowEx(0, "Button", "Check!", WS_CHILD | WS_VISIBLE, 10, 135 + 25, 280, 25, hwnd, NULL, hinst, NULL);
    hbutton_about = CreateWindowEx(0, "Button", "About", WS_CHILD | WS_VISIBLE, 10, 135 + 25 + 30, 280, 25, hwnd, NULL, hinst, NULL);
    break;

    case WM_COMMAND:
    if ((HWND)lParam == hbutton_about) {
      MessageBox(hwnd,
        "Brutal OldSkull CrackMe\r\n"
        "\r\n"
        "Somewhat '90 style!\r\n"
        "by Gynvael Coldwind\r\n"
        "Teaser Dragon CTF 2018\r\n",

        "About?",
        MB_YESNOCANCEL | MB_ICONINFORMATION);
      return 0;
    }

    if ((HWND)lParam == hbutton_check) {
      CheckFlag();
      return 0;
    }
    break;

    case WM_CLOSE:
    DestroyWindow(hwnd);
    break;

    case WM_DESTROY:
    PostQuitMessage(0);
    break;

    default:
    return DefWindowProc(hwnd, msg, wParam, lParam);
  }
  return 0;
}

int WINAPI WinMain(
    HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow) {
  (void)hPrevInstance;
  (void)lpCmdLine;
  hinst = hInstance;

  WNDCLASSEX wc;
  HWND hwnd;
  MSG Msg;

  wc.cbSize         = sizeof(WNDCLASSEX);
  wc.style          = 0;
  wc.lpfnWndProc    = WndProc;
  wc.cbClsExtra     = 0;
  wc.cbWndExtra     = 0;
  wc.hInstance      = hInstance;
  wc.hIcon          = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground  = (HBRUSH)(COLOR_WINDOW);
  wc.lpszMenuName   = NULL;
  wc.lpszClassName  = WINDOW_CLASS_NAME;
  wc.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

  if(!RegisterClassEx(&wc)) {
    MessageBox(NULL, "Window Registration Failed!", "Error!",
                MB_ICONEXCLAMATION | MB_OK);
    return 0;
  }

  hwnd = CreateWindowEx(
   0,
   WINDOW_CLASS_NAME,
   WINDOW_NAME,
   WS_OVERLAPPEDWINDOW,
   150, 150,
   320, 260,
   NULL, NULL, hInstance, NULL);

  if(!hwnd) {
    MessageBox(NULL, "Window Creation Failed!", "Error!",
                MB_ICONEXCLAMATION | MB_OK);
    return 0;
  }

  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  while(GetMessage(&Msg, NULL, 0, 0)) {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
  }

  return Msg.wParam;
}

